const express = require('express');
// const bodyParser = require('body-parser');
const IpUtil = require('./utils/IpUtil');
const rs6 = require("./routes/Rs6");
const sm4 = require("./routes/Sm4");
const fp = require("./routes/Fp");
// 读取环境变量
const port = process.env.PORT || 9081;
const nodeEnv = process.env.NODE_ENV || 'dev';

/**
 * 初始化框架,并将初始化后的函数给予 '当前页面'全局变量 app
 * 也就是说, app 是 express
 */
const app = express();


/* 配置框架环境 S */
// 设置 express 的中间件 body-parser
app.use(express.json({limit: '10mb'}));
app.use(express.urlencoded({limit: '10mb', extended: true}));

// 设置 public 为静态文件的存放文件夹
// app.use('/public', express.static('public'));

/* 配置框架环境 E */
app.use("/rs", rs6);
app.use("/sm", sm4);
app.use("/fp", fp);
app.listen(port, "0.0.0.0", () => {
    const ips = IpUtil.getLocalIPs();
    for (let ip of ips) {
        console.log(`${nodeEnv} Node.JS 服务器已启动，访问地址： http://${ip}:${port}`)
    }
});