const AreaNameEnum = Object.freeze({
    BEI_JING: Object.freeze({
        AREA_CODE: '1100',
        AREA_NAME: 'beijing',
    }),
    TIAN_JING: Object.freeze({
        AREA_CODE: '1200',
        AREA_NAME: 'tianjing',
    }),
    HE_BEI: Object.freeze({
        AREA_CODE: '1300',
        AREA_NAME: 'hebei',
    }),
    NEI_MENG: Object.freeze({
        AREA_CODE: '1500',
        AREA_NAME: 'neimeng',
    }),
    LIAO_NING: Object.freeze({
        AREA_CODE: '2100',
        AREA_NAME: 'liaoning',
    }),
    DA_LIAN: Object.freeze({
        AREA_CODE: '2102',
        AREA_NAME: 'dalian',
    }),
    JI_LIN: Object.freeze({
        AREA_CODE: '2200',
        AREA_NAME: 'jilin',
    }),
    HEI_LONG_JIANG: Object.freeze({
        AREA_CODE: '2300',
        AREA_NAME: 'heilongjiang',
    }),
    SHANG_HAI: Object.freeze({
        AREA_CODE: '3100',
        AREA_NAME: 'shanghai',
    }),
    JIANG_SU: Object.freeze({
        AREA_CODE: '3200',
        AREA_NAME: 'jiangsu',
    }),
    ZHE_JIANG: Object.freeze({
        AREA_CODE: '3300',
        AREA_NAME: 'zhejiang',
    }),
    NING_BO: Object.freeze({
        AREA_CODE: '3302',
        AREA_NAME: 'ningbo',
    }),
    AN_HUI: Object.freeze({
        AREA_CODE: '3400',
        AREA_NAME: 'anhui',
    }),
    FU_JIAN: Object.freeze({
        AREA_CODE: '3500',
        AREA_NAME: 'fujian',
    }),
    XIA_MEN: Object.freeze({
        AREA_CODE: '3502',
        AREA_NAME: 'xiamen',
    }),
    JIANG_XI: Object.freeze({
        AREA_CODE: '3600',
        AREA_NAME: 'jiangxi',
    }),
    SHAN_DONG: Object.freeze({
        AREA_CODE: '3700',
        AREA_NAME: 'shandong',
    }),
    QING_DAO: Object.freeze({
        AREA_CODE: '3702',
        AREA_NAME: 'qingdao',
    }),
    HE_NAN: Object.freeze({
        AREA_CODE: '4100',
        AREA_NAME: 'henan',
    }),
    HU_BEI: Object.freeze({
        AREA_CODE: '4200',
        AREA_NAME: 'hubei',
    }),
    HU_NAN: Object.freeze({
        AREA_CODE: '4300',
        AREA_NAME: 'hunan',
    }),
    GUANG_DONG: Object.freeze({
        AREA_CODE: '4400',
        AREA_NAME: 'guangdong',
    }),
    SHEN_ZHEN: Object.freeze({
        AREA_CODE: '4403',
        AREA_NAME: 'shenzhen',
    }),
    GUANG_XI: Object.freeze({
        AREA_CODE: '4500',
        AREA_NAME: 'guangxi',
    }),
    HAI_NAN: Object.freeze({
        AREA_CODE: '4600',
        AREA_NAME: 'hainan',
    }),
    CHONG_QING: Object.freeze({
        AREA_CODE: '5000',
        AREA_NAME: 'chongqing',
    }),
    SI_CHUAN: Object.freeze({
        AREA_CODE: '5100',
        AREA_NAME: 'sichuan',
    }),
    GUI_ZHOU: Object.freeze({
        AREA_CODE: '5200',
        AREA_NAME: 'guizhou',
    }),
    YUN_NAN: Object.freeze({
        AREA_CODE: '5300',
        AREA_NAME: 'yunnan',
    }),
    XI_ZANG: Object.freeze({
        AREA_CODE: '5400',
        AREA_NAME: 'xizang',
    }),
    SHAN_XI: Object.freeze({
        AREA_CODE: '6100',
        AREA_NAME: 'shanxi',
    }),
    GAN_SU: Object.freeze({
        AREA_CODE: '6200',
        AREA_NAME: 'gansu',
    }),
    QING_HAI: Object.freeze({
        AREA_CODE: '6300',
        AREA_NAME: 'qinghai',
    }),
    NING_XIA: Object.freeze({
        AREA_CODE: '6300',
        AREA_NAME: 'ningxia',
    }),
    XIN_JIANG: Object.freeze({
        AREA_CODE: '6500',
        AREA_NAME: 'xinjiang',
    }),

    getByAreaCode(areaCode) {
        if (areaCode == null) {
            return Object();
        }
        for (const key in this) {
            if (this[key] && this[key].AREA_CODE === areaCode.toString()) {
                return this[key];
            }
        }
        return Object();
    },
    getByAreaName(areaName) {
        if (areaName == null) {
            return Object();
        }
        for (const key in this) {
            if (this[key] && this[key].AREA_NAME === areaName.toString()) {
                return this[key];
            }
        }
        return Object();
    },
});

module.exports = AreaNameEnum;
