const os = require('node:os');

class IpUtil {
    static networkInterfaces = os.networkInterfaces(); // 私有静态属性，用于缓存网络接口信息

    static getLocalIPs() {
        let ipAddresses = [];
        for (const face in this.networkInterfaces) {
            for (const address of this.networkInterfaces[face]) {
                if (address.family === 'IPv4' && !address.internal) {
                    ipAddresses.push(address.address);
                }
            }
        }
        return ipAddresses;
    }
}

module.exports = IpUtil;
